//---------------------------------------------------------------------------


#pragma hdrstop

#include <windows.h>
#include "main.h"
#include "port.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

void Priorita(short int i) { //0=realtime; 1=high; 2=normal
 switch (i) {
  case 0:
   SetPriorityClass(GetCurrentProcess(), REALTIME_PRIORITY_CLASS);
   SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_TIME_CRITICAL);
   break;
  case 1:
   SetPriorityClass(GetCurrentProcess(), HIGH_PRIORITY_CLASS);
   SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_NORMAL);
   break;
  default:
  case 2:
   SetPriorityClass(GetCurrentProcess(), NORMAL_PRIORITY_CLASS);
   SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_NORMAL);
   break;
 }
}

void Delayus(unsigned __int64 prodleva)
{
 unsigned __int64 frekvence,citac,stop;
  if (!QueryPerformanceCounter((LARGE_INTEGER *)&citac)) return;
  if (!QueryPerformanceFrequency((LARGE_INTEGER *)&frekvence)) return;
  stop=((prodleva*frekvence)/1000000)+citac+1;
  while  (stop>citac) QueryPerformanceCounter((LARGE_INTEGER *)&citac);
}

TPort::TPort() {hCom=NULL;}
TPort::~TPort() {Close();}

void TPort::DTR(bool on) {
  EscapeCommFunction(hCom,on ? SETDTR : CLRDTR);
};

void TPort::RTS(bool on) {
  EscapeCommFunction(hCom,on ? SETRTS : CLRRTS);
};

void TPort::TxD(bool on) {
  EscapeCommFunction(hCom,on ? SETBREAK : CLRBREAK );
}

bool TPort::CTS() {
  GetCommModemStatus(hCom,&lpModemStat);
  return (lpModemStat & MS_CTS_ON);
};

bool TPort::DSR() {
  GetCommModemStatus(hCom,&lpModemStat);
  return (lpModemStat & MS_DSR_ON);
};

bool TPort::RI() {
  GetCommModemStatus(hCom,&lpModemStat);
  return (lpModemStat & MS_RING_ON);
};

bool TPort::DCD() {
  GetCommModemStatus(hCom,&lpModemStat);
  return (lpModemStat & MS_RLSD_ON);
};

bool TPort::Opened()
{
  return hCom;
}

bool TPort::Open(char *pcCommPort)
{
  if (hCom) Close();
 hCom = CreateFile( pcCommPort,
  GENERIC_READ | GENERIC_WRITE,
  0,    // comm devices must be opened w/exclusive-access
  NULL, // no security attributes
  OPEN_EXISTING, // comm devices must use OPEN_EXISTING
  FILE_FLAG_OVERLAPPED|FILE_FLAG_NO_BUFFERING,    // overlapped I/O
  NULL  // hTemplate must be NULL for comm devices
  );
 if (hCom == INVALID_HANDLE_VALUE)
 {
   hCom=NULL;
   return false;
 }
 return true;
}

void TPort::Close()
{
 if (hCom) CloseHandle(hCom); hCom=NULL;
}

void TCasovac::Start(unsigned int) {
  if(timerID) Stop();
  timerID = timeSetEvent(10, 0, TimeProc, 0, TIME_PERIODIC);
  if (timerID) Started=true;
}

void TCasovac::Stop() {
  Started=false;
  if (timerID) timeKillEvent(timerID);
}

void CALLBACK TimeProc(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2) {
  PostMessage(Form1->Handle,WM_USER,NULL,1L);
};
